package gps_test

import (
	"fmt"

	"mfs.de/gps"
)

func ExampleCoordinatesWithLatLong() {
	hamburg := gps.CoordinatesWithLatLong(53.551086, 9.993682)
	fmt.Printf("%#v\n", hamburg)

	rio := gps.CoordinatesWithLatLong(-22.908333, -43.196388)
	fmt.Printf("%#v\n", rio)

	ottawa := gps.CoordinatesWithLatLong(45.424721, -75.695000)
	fmt.Printf("%#v\n", ottawa)

	sydney := gps.CoordinatesWithLatLong(-33.865143, 151.209900)
	fmt.Printf("%#v\n", sydney)

	outOfBounds := gps.CoordinatesWithLatLong(255.0, 1024)
	fmt.Printf("%#v\n", outOfBounds)
	outOfBounds = gps.CoordinatesWithLatLong(-255.0, 1024)
	fmt.Printf("%#v\n", outOfBounds)
	outOfBounds = gps.CoordinatesWithLatLong(255.0, -1024)
	fmt.Printf("%#v\n", outOfBounds)
	outOfBounds = gps.CoordinatesWithLatLong(-255.0, -1024)
	fmt.Printf("%#v\n", outOfBounds)
	// Output:
	// gps.Coordinates{latitude:53.551086, longitude:9.993682}
	// gps.Coordinates{latitude:-22.908333, longitude:-43.196388}
	// gps.Coordinates{latitude:45.424721, longitude:-75.695}
	// gps.Coordinates{latitude:-33.865143, longitude:151.2099}
	// gps.Coordinates{latitude:90, longitude:180}
	// gps.Coordinates{latitude:-90, longitude:180}
	// gps.Coordinates{latitude:90, longitude:-180}
	// gps.Coordinates{latitude:-90, longitude:-180}
}

func ExampleCoordinates_SetLatitude() {
	coordinate := gps.Coordinates{}

	coordinate.SetLatitude(10.83)
	fmt.Println(coordinate.Latitude())

	coordinate.SetLatitude(-23.4)
	fmt.Println(coordinate.Latitude())

	coordinate.SetLatitude(108.3)
	fmt.Println(coordinate.Latitude())
	coordinate.SetLatitude(-234.5)
	fmt.Println(coordinate.Latitude())
	// Output:
	// 10.83
	// -23.4
	// 90
	// -90
}

func ExampleCoordinates_SetLongitude() {
	coordinate := gps.Coordinates{}

	coordinate.SetLongitude(9.54)
	fmt.Println(coordinate.Longitude())

	coordinate.SetLongitude(-123.45)
	fmt.Println(coordinate.Longitude())

	coordinate.SetLongitude(954.1)
	fmt.Println(coordinate.Longitude())
	coordinate.SetLongitude(-1234.5)
	fmt.Println(coordinate.Longitude())
	// Output:
	// 9.54
	// -123.45
	// 180
	// -180
}
