// Objective-C API for talking to mfs.de/spacedata Go package.
//   gobind -lang=objc mfs.de/spacedata
//
// File is generated by gobind. Do not edit.

#ifndef __Spacedata_H__
#define __Spacedata_H__

@import Foundation;
#include "Universe.objc.h"


@class SpacedataAstronauts;
@class SpacedataCoordinate;
@class SpacedataLocationProvider;
@class SpacedataPassTimeProvider;
@class SpacedataPeopleDataSet;
@class SpacedataPeopleProvider;
@class SpacedataPeopleStorage;
@class SpacedataRisings;
@protocol SpacedataProviding;
@class SpacedataProviding;

@protocol SpacedataProviding <NSObject>
- (NSString*)endpointString;
- (NSData*)parseResponse:(NSData*)p0 error:(NSError**)error;
@end

@interface SpacedataAstronauts : NSObject <goSeqRefInterface> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (instancetype)init;
- (NSString*)name;
- (void)setName:(NSString*)v;
- (NSString*)ship;
- (void)setShip:(NSString*)v;
@end

@interface SpacedataCoordinate : NSObject <goSeqRefInterface> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (instancetype)init;
- (NSString*)latitude;
- (void)setLatitude:(NSString*)v;
- (NSString*)longitude;
- (void)setLongitude:(NSString*)v;
// skipped method Coordinate.GpsCoordinate with unsupported parameter or return types

@end

@interface SpacedataLocationProvider : NSObject <goSeqRefInterface, SpacedataProviding> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (instancetype)init;
- (NSString*)endpointString;
- (NSData*)parseResponse:(NSData*)jsonData error:(NSError**)error;
@end

@interface SpacedataPassTimeProvider : NSObject <goSeqRefInterface, SpacedataProviding> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (instancetype)init;
- (NSString*)endpointString;
- (NSData*)parseResponse:(NSData*)jsonData error:(NSError**)error;
@end

@interface SpacedataPeopleDataSet : NSObject <goSeqRefInterface> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (instancetype)init;
- (NSString*)name;
- (void)setName:(NSString*)v;
- (NSString*)craft;
- (void)setCraft:(NSString*)v;
@end

@interface SpacedataPeopleProvider : NSObject <goSeqRefInterface, SpacedataProviding> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (instancetype)init;
- (NSString*)databaseDirectory;
- (void)setDatabaseDirectory:(NSString*)v;
- (NSString*)endpointString;
- (NSData*)parseResponse:(NSData*)jsonData error:(NSError**)error;
@end

@interface SpacedataPeopleStorage : NSObject <goSeqRefInterface> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (instancetype)init;
- (NSString*)databaseName;
- (void)setDatabaseName:(NSString*)v;
- (NSString*)databasePath;
- (void)setDatabasePath:(NSString*)v;
- (SpacedataPeopleDataSet*)get:(int64_t)row error:(NSError**)error;
// skipped method PeopleStorage.GetPassengers with unsupported parameter or return types

- (BOOL)post:(SpacedataPeopleDataSet*)d ret0_:(int64_t*)ret0_ error:(NSError**)error;
@end

@interface SpacedataRisings : NSObject <goSeqRefInterface> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (instancetype)init;
- (int64_t)rising;
- (void)setRising:(int64_t)v;
- (int64_t)duration;
- (void)setDuration:(int64_t)v;
- (NSString*)isoDateString;
@end

@class SpacedataProviding;

@interface SpacedataProviding : NSObject <goSeqRefInterface, SpacedataProviding> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (NSString*)endpointString;
- (NSData*)parseResponse:(NSData*)p0 error:(NSError**)error;
@end

#endif
